<?php
namespace Neuron\Person;

use Neuron\Person\Map;
use Neuron\Person\Map\Storage;
use Neuron\Generic\Result;

class Maps extends \Neuron\Generic\Set {
		
	protected $_storage;

	public function __construct(\Neuron\Person\Map\Storage\Skeleton $storage) {
			
		$this->_storage = $storage;
	}

	public function load($id = null, $mode = Storage::LIST_ALL,$params = array()){
        $result     = new Result();
        $data       = $this->_storage->loadList($id,$mode,$params);
        if($data){
            $rows   = $data->rows;
            $list   = array();

            if($rows){
                foreach($rows as $row){
                    $row = array_change_key_case($row);
                    unset($row['b_rownum']);
    
                    $entity     = new Map($this->_storage);
                    $entity->push($data);
                    $this->add($entity);
                    $list[]     = $row;
                }
            }
            
            $resData        = array(
                'rows'      => $list,
                'countTotal' => $data->countTotal
            );
            $result->data   = $resData;
            $result->info   = "Success loading Person data";

        }else{
            $result->code = 411;
            $result->info = 'Failed loading data';
        }

        return $result;
    }

}