<?php

namespace Neuron\Person;

use Neuron\Generic\Entity\Map;
use Neuron\Generic\Result;

class Parameters extends \Neuron\Generic\Entity\Mapper {
		
	protected $_storage;

    public function __construct(\Neuron\Person\Parameter\Storage\Skeleton $storage, $data = array()) {

        $this->_storage = $storage;

        parent::__construct(
            $data, 
            array(
                new Map('param_id'),
                new Map('param_ref_name'),
                new Map('param_ref_id'),
                new Map('value1'),
                new Map('value2'),
                new Map('description'),
                new Map('start_date'),
                new Map('end_date')
            ), 
            parent::CASE_INSENSITIVE
        );
    }

	public function listparam($ids = null, $params = array()) {
		$data = $this->_storage->listparam($ids, $params);
		return $data;
	}
	
	public function lists($page = 0 , $rowCount= 10, $filter = array(), $order = array()){
		$result = $this->_storage->lists($page, $rowCount, $filter, $order);
		$arrref = array();
		if ($result) {
			foreach ($result as $data) {
				$data['param_id'] = intval($data['param_id']);
				array_push($arrref, $data);
			}
		}
		// print_r($arrref); die();

		$total = $this->_storage->getTotalRows();
		
		$retval = array(
			'current' => $page,
			'rowCount' => $rowCount,
			'rows' => $arrref,
			'total' => $total
		);

		return $retval;
	}

	public function load($param_id=null)
	{
		$data = $this->_storage->load($param_id);
		if($data){
			$this->push($data);
			return $data;
		}
		return false;
	}

	public function loadBY($filter=array())
	{
		$data = $this->_storage->loadBY($filter);
		if($data){
			return $data;
		}
		return false;
	}

	public function save($update)
	{
		if ($id = $this->_storage->save($this, $update)) {
        	$this->param_id = $id;
        	return true;
      	}
      	return false;
	}

	public function terminate($data) {
        return $this->_storage->remove($data);
    
    }
    public function delete($id){
    	return $this->_storage->deleteFromDb($id);
    }
}